/*
 *  Header for the Amiga Shared library code for the GNU regular
 *  expression package. Edwin Hoogerbeets 18/07/89
 *
 *  This file may be copied and distributed under the GNU Public
 *  Licence. See the comment at the top of regex.c for details.
 *
 *  Adapted from Elib by Jim Mackraz, mklib by Edwin Hoogerbeets, and the
 *  GNU regular expression package by the Free Software Foundation.
 */

#include <exec/types.h>
#include <exec/nodes.h>
#include <exec/resident.h>
#include <exec/libraries.h>

#include <functions.h>

typedef LONG (*PFL)();      /* pointer to function returning 32-bit int */

/* library initialization table, used for AUTOINIT libraries                    */
struct InitTable {
    ULONG   it_DataSize;    /* library data space size          */
    PFL     *it_FuncTable;  /* table of entry points            */
    APTR    it_DataInit;    /* table of data initializers       */
    PFL     it_InitFunc;    /* initialization function to run   */
};

#ifndef ALIGN_SIZE
#define ALIGN_SIZE      sizeof(double)
#endif

struct RegexBase {
    struct  Library rb_Lib;
    ULONG   rb_Cookie;      /* looks good                       */
    ULONG   rb_SegList;
    ULONG   rb_Flags;
    APTR    rb_ExecBase;    /* pointer to exec base             */
    APTR    rb_A4;          /* proper value of A4 for aztec small model */
};



